#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var commander_1 = __importDefault(require("commander"));
var index_1 = require("./index");
commander_1.default
    .description("Publish Android App Bundle to Google Play")
    .requiredOption("-k, --keyFile <path>", "set google api json key file")
    .requiredOption("-p, --packageName <name>", "set package name (com.some.app)")
    .requiredOption("-a, --aabFile <path>", "set path to .aab file")
    .requiredOption("-t, --track <track>", "set track (production, beta, alpha...)")
    .requiredOption("-r, --releaseNote <note>", "set release note (only for en-US)")
    .option("-e, --exit", "exit on error with error code 1.")
    .parse(process.argv);
index_1.publish({
    keyFile: path_1.join(process.cwd(), commander_1.default.keyFile),
    packageName: commander_1.default.packageName,
    aabFile: path_1.join(process.cwd(), commander_1.default.aabFile),
    track: commander_1.default.track,
    releaseNote: commander_1.default.releaseNote,
})
    .then(function () {
    console.log("Publish complete.");
})
    .catch(function (error) {
    console.error(error.message);
    process.exit(commander_1.default.exit ? 1 : 0);
});
